RHEL 6: sr_mod.ko is needed for RHEL 6 to see CD-ROM devices (RHBZ#598807).
[libguestfs.git] / fuse / test-fuse.sh
1 #!/bin/bash -
2 # libguestfs
3 # Copyright (C) 2009 Red Hat Inc.
4 #
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write to the Free Software
17 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
18
19 unset CDPATH
20 set -e
21 #set -v
22
23 if [ -z "$top_builddir" ]; then
24     echo "$0: error: environment variable \$top_builddir must be set"
25     exit 1
26 fi
27
28 nr_stages=$(grep "^stage " $0 | wc -l)
29
30 # Allow top_builddir to be a relative path, but also make it absolute,
31 # and move to that directory for the initial phase of the script.
32 top_builddir=$(cd "$top_builddir" > /dev/null; pwd)
33
34 # Set libguestfs up for running locally.
35 export LIBGUESTFS_PATH="$top_builddir/appliance"
36
37 # Paths to the other programs and files.  NB: Must be absolute paths.
38 guestfish="$top_builddir/fish/guestfish"
39 guestmount="$top_builddir/fuse/guestmount"
40 image="$top_builddir/fuse/test.img"
41 mp="$top_builddir/fuse/test-mp"
42
43 if [ ! -x "$guestfish" -o ! -x "$guestmount" ]; then
44     echo "$0: error: guestfish or guestmount are not available"
45     exit 1
46 fi
47
48 # Ensure everything is cleaned up on exit.
49 rm -f "$image"
50 mkdir -p "$mp"
51 fusermount -u "$mp" >/dev/null 2>&1 ||:
52 function cleanup ()
53 {
54     status=$?
55     set +e
56     [ $status = 0 ] || echo "*** FAILED ***"
57     echo "Unmounting filesystem and cleaning up."
58
59     # Move out of the mountpoint (otherwise our cwd will prevent the
60     # mountpoint from being unmounted).
61     cd "$top_builddir"
62
63     # Who's using this?  Should be no one, but see below.
64     if [ -x /sbin/fuser ]; then /sbin/fuser "$mp"; fi
65
66     # If you run this and you have GNOME running at the same time,
67     # then randomly /usr/libexec/gvfs-gdu-volume-monitor will decide
68     # to do whatever it does in the mountpoint directory, preventing
69     # you from unmounting it!  Hence the need for this loop.
70     count=10
71     while ! fusermount -u "$mp" && [ $count -gt 0 ]; do
72         sleep 1
73         ((count--))
74     done
75
76     rm -f "$image"
77     rm -rf "$mp"
78     exit $status
79 }
80 trap cleanup INT TERM QUIT EXIT
81
82 s=1
83 function stage ()
84 {
85     echo "test-fuse: $s/$nr_stages:" "$@" "..."
86     ((s++))
87 }
88
89 stage Create filesystem with some initial content
90 $guestfish <<EOF
91   sparse "$image" 10M
92   run
93   part-disk /dev/sda mbr
94   mkfs ext2 /dev/sda1
95   mount /dev/sda1 /
96   write /hello.txt hello
97   write /world.txt "hello world"
98   touch /empty
99 EOF
100
101 stage Mounting the filesystem
102 $guestmount -a "$image" -m /dev/sda1 "$mp"
103
104 stage Changing into mounted directory
105 cd "$mp"
106
107 stage Checking initial files exist
108 [ -n "$(echo *)" ]
109 [ "$(ls empty hello.txt world.txt)" = "empty
110 hello.txt
111 world.txt" ]
112
113 stage Checking initial files contain expected content
114 [ "$(cat hello.txt)" = "hello" ]
115 [ "$(cat world.txt)" = "hello world" ]
116 cat empty ;# should print nothing
117 [ -z "$(cat empty)" ]
118
119 stage Checking file modes of initial content
120 [ "$(stat -c %a empty)" = "644" ]
121 [ "$(stat -c %a hello.txt)" = "644" ]
122 [ "$(stat -c %a world.txt)" = "644" ]
123
124 stage Checking sizes of initial content
125 [ "$(stat -c %s empty)" -eq 0 ]
126 [ "$(stat -c %s hello.txt)" -eq 5 ]
127 [ "$(stat -c %s world.txt)" -eq 11 ]
128
129 stage Checking unlink
130 touch new
131 rm -f new ;# force because file is "owned" by root
132
133 stage Checking symbolic link
134 ln -s hello.txt symlink
135 [ -L symlink ]
136
137 stage Checking readlink
138 [ "$(readlink symlink)" = "hello.txt" ]
139
140 stage Checking hard link
141 [ "$(stat -c %h hello.txt)" -eq 1 ]
142 ln hello.txt link
143 [ "$(stat -c %h link)" -eq 2 ]
144 [ "$(stat -c %h hello.txt)" -eq 2 ]
145 rm -f link
146 [ ! -e link ]
147
148 # This fails because of caching.  The problem is that the linked file
149 # ("hello.txt") is cached with a link count of 2.  unlink("link")
150 # invalidates the cache for "link", but _not_ for "hello.txt" which
151 # still has the now-incorrect cached value.  However there's not much
152 # we can do about this since searching for all linked inodes of a file
153 # is an O(n) operation.
154 #[ "$(stat -c %h hello.txt)" -eq 1 ]
155
156 stage Checking mkdir
157 mkdir newdir
158 [ -d newdir ]
159
160 stage Checking rmdir
161 rmdir newdir
162 [ ! -e newdir ]
163
164 stage Checking rename
165 touch old
166 mv old new
167 [ -f new ]
168 [ ! -e old ]
169 rm -f new
170
171 stage Checking chmod
172 touch new
173 chmod a+x new
174 [ -x new ]
175 chmod a-x new
176 [ ! -x new ]
177 chmod a-w new
178 [ ! -w new ]
179 chmod a+w new
180 [ -w new ]
181 chmod a-r new
182 [ ! -r new ]
183 chmod a+r new
184 [ -r new ]
185 rm -f new
186
187 stage Checking truncate
188 truncate -s 10000 truncated
189 [ "$(stat -c %s truncated)" -eq 10000 ]
190 truncate -c -s 1000 truncated
191 [ "$(stat -c %s truncated)" -eq 1000 ]
192 truncate -c -s 10 truncated
193 [ "$(stat -c %s truncated)" -eq 10 ]
194 truncate -c -s 0 truncated
195 [ "$(stat -c %s truncated)" -eq 0 ]
196 rm -f truncated
197
198 stage Checking utimens and timestamps
199 for ts in 12345 1234567 987654321; do
200     # NB: It's not possible to set the ctime with touch.
201     touch -a -d @$ts timestamp
202     [ "$(stat -c %X timestamp)" -eq $ts ]
203     touch -m -d @$ts timestamp
204     [ "$(stat -c %Y timestamp)" -eq $ts ]
205     touch    -d @$ts timestamp
206     [ "$(stat -c %X timestamp)" -eq $ts ]
207     [ "$(stat -c %Y timestamp)" -eq $ts ]
208 done
209
210 stage Checking writes
211 cp hello.txt copy.txt
212 echo >> copy.txt
213 echo world >> copy.txt
214 echo bigger >> copy.txt
215 echo biggest >> copy.txt
216 [ "$(cat copy.txt)" = "hello
217 world
218 bigger
219 biggest" ]
220
221 # These ones are not yet tested by the current script:
222 #stage XXX statfs/statvfs
223 #stage XXX xattr operations
224
225 # These ones cannot easily be tested by the current script, eg because
226 # this script doesn't run as root:
227 #stage XXX fsync
228 #stage XXX chown
229 #stage XXX mknod